device_type: qemu
job_name: EWAOL boot test qemu-arm64
timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2
priority: 25
visibility: public
context:
  arch: aarch64
  machine: virt,secure=on
  cpu: cortex-a57
  guestfs_interface: virtio
  netdevice: user
actions:
- deploy:
    namespace: target
    timeout:
      minutes: 15
    to: tmpfs
    images:
      1rootfs:
        image_arg: -drive id=disk1,file={1rootfs},if=none,format=raw -device virtio-blk-device,drive=disk1
          -nographic -device i6300esb,id=watchdog0 -m 2048 -smp 4
        url: {{ rootfs_url }}
        compression: bz2
        apply-overlay: true
        sparse: false
      2certs:
        image_arg: -drive id=disk0,file={2certs},if=none,format=raw -device virtio-blk-device,drive=disk0
        url: {{ cert_image_url }}
      3bios:
        image_arg: -drive if=pflash,unit=0,readonly=off,file={3bios},format=raw
        url: {{ bios_url }}
    os: oe


# boot to uboot
- boot:
    namespace: target
    timeout:
      minutes: 2
    method: qemu
    media: tmpfs
    docker:
      image: linaro/ci-amd64-ledge:stable
      binary: /usr/bin/qemu-system-aarch64
    expect_shell: false
    auto_login:
      login_prompt: 'Hit any key to stop autoboot'
      username: " "
    parameters:
      kernel-start-message: "Booting Trusted Firmware"
    prompts:
    - '=>'
    boot_finished:
    - '=>'

# configure to boot the image
- test:
    namespace: target
    timeout:
      minutes: 10
    interactive:
    - name: basic-cmds
      prompts: ['=> ', 'Booting:']
      script:
      - command: "virtio scan"
      - command: ""
      - command: "ls virtio 1 && ls virtio 0"
      - command: ""
      - command: "printenv"
      - command: ""   
      # FIXME: Remove line below when we can get signed EWAOL kernels
      - command: "load virtio 0 90000000 SecureBoot_noPK.auth && setenv -e -nv -bs -rt -at -i 90000000:$filesize PK"
      - command: ""
      # FIXME: Line below does not yet work, we need to change it when we figure how to properly boot ewaol images
      - command: "efidebug boot add -b 1 BootLedge virtio 1:1 efi/boot/bootaa64.efi -i virtio 1:1 ledge-initramfs.rootfs.cpio.gz -s 'console=ttyAMA0,115200 console=tty0 root=UUID=6091b3a4-ce08-3020-93a6-f755a22ef03b rootwait panic=60'"
      - command: ""
      - command: "efidebug boot order 1"
      - command: ""
      - command: "setenv bootcmd 'bootefi bootmgr'"
      - command: ""
      - command: "saveenv"
      - command: ""
      - command: "bootefi bootmgr"

# wait for boot to userspace
- boot:
    namespace: target
    timeout:
      minutes: 20
    method: minimal
    reset: false
    prompts:
      # FIXME: Figure out what the correct prompt is after we get to boot ewaol
      - 'ledge-qemuarm64:'
    auto_login:
      # FIXME: Figure out username and password
      login_prompt: 'login:'
      username: "ledge"
      password_prompt: 'Password:'
      password: "ledge"

## TODO run userspace test
#- test:
#    namespace: target
#    timeout:
#      minutes: 5
#    definitions:
#      - repository:
#          metadata:
#            format: Lava-Test Test Definition 1.0
#            name: smoke-tests-basic
#            description: "A few basic commands"
#            os:
#              - debian
#            scope:
#              - functional
#          run:
#            steps:
#              - env
#              - date
#              - hostname
#              - ip a || true
#        from: inline
#        path: inline-smoke-test
#        name: inline-test
